<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ns2="http://schema.samply.de/ccp/Value" xmlns:ns3="http://schema.samply.de/ccp/Attribute" xmlns:ns4="http://schema.samply.de/ccp/Container"
	xmlns:ns5="http://schema.samply.de/ccp/MdrKey" xmlns:ns6="http://schema.samply.de/ccp/Case" xmlns:ns7="http://schema.samply.de/ccp/Sample" xmlns:ns8="http://schema.samply.de/ccp/Patient">
	<xsl:strip-space  elements="*"/>
	<xsl:output method="xml" indent="yes" omit-xml-declaration="yes" />
	
	<!-- By default, recursively copy all nodes unchanged -->
	<xsl:template match="@* | node()">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()" />
		</xsl:copy>
	</xsl:template>

	<!-- If Patient has no Diagnosis/Case - add one -->
	<xsl:template match="ns8:Patient">
		<xsl:variable name="vDiagnosis" select="'Diagnosis'" />
		<xsl:choose>
			<xsl:when test="boolean(ns4:Container/@designation = $vDiagnosis)">
				<ns8:Patient>
					<xsl:attribute name="id">
						<xsl:value-of select="@id" />
					</xsl:attribute>
					<xsl:apply-templates select="@* | node()" />
				</ns8:Patient>
			</xsl:when>
			<xsl:otherwise>
				<ns8:Patient>
					<xsl:attribute name="id">
						<xsl:value-of select="@id" />
					</xsl:attribute>
					<xsl:apply-templates select="@* | node()" />
					<ns6:Case id="1">
						<!-- Insert the mdsk-nodes of the parent here -->
						<xsl:copy-of select="./ns3:Attribute" />						
					</ns6:Case>
				</ns8:Patient>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Remove all Container Nodes... -->
	<xsl:template match="ns4:Container" />
	
	<!-- Remove all attributes from patients -->
	<xsl:template match="ns8:Patient/ns3:Attribute" />
	
	<!-- Remove all ref from samples -->
<!-- 	<xsl:template match="ns4:Container[@designation='Sample']/Ref" /> -->

	<!-- Use Diagnosis Containers as Cases -->
	<xsl:template match="ns4:Container[@designation='Diagnosis']" name="cases">
		<ns6:Case>
			<xsl:attribute name="id">
				<xsl:value-of select="@id" />
			</xsl:attribute>
			<!-- Insert the mdsk-nodes of the parent here -->
			<xsl:copy-of select="../ns3:Attribute" />
			<xsl:apply-templates select="@*[name(.)!='designation']|node()" />
		</ns6:Case>
	</xsl:template>
	
	<!-- and Sample Containers as Samples -->
	<xsl:template match="ns4:Container[@designation='Sample']">
		<ns7:Sample>
<!-- 			<xsl:if test="Ref/EntityId"> -->
<!-- 				<xsl:attribute name="refToCase"> -->
<!-- 					<xsl:value-of select="Ref/EntityId" /> -->
<!-- 				</xsl:attribute> -->
<!-- 			</xsl:if> -->
			<!-- Without the following xsl:attribute statement, xslt removes the id from the sample... -->
			<xsl:attribute name="id">
				<xsl:value-of select="@id" />
			</xsl:attribute>
			<!-- Copy the id attribute to the id element (85) -->
<!-- 			<ns3:Attribute> -->
<!-- 				<ns5:MdrKey>urn:mdr:dataelement:85:1.0</ns5:MdrKey> -->
<!-- 				<ns2:Value> -->
<!-- 					<xsl:value-of select="@id" /> -->
<!-- 				</ns2:Value> -->
<!-- 			</ns3:Attribute> -->
			<!-- Add elements from subcontainers here (like Tumour/TNM Tumour/Histology) -->
			<xsl:copy-of select=".//ns3:Attribute" />
			
			<xsl:apply-templates select="@*[name(.)!='designation']|node()" />
		</ns7:Sample>
	</xsl:template>

</xsl:stylesheet>
